﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

// Serialization
using System.Runtime.Serialization.Json;
using System.IO;

namespace Pixotope
{
    static class SerializationUtils
    {
        public static string SerializeJSON<T>(T Object)
        {
            using (MemoryStream MemoryStream = new MemoryStream())
            {
                DataContractJsonSerializer Serializer = new DataContractJsonSerializer(typeof(T));
                Serializer.WriteObject(MemoryStream, Object);
                MemoryStream.Position = 0;
                StreamReader StreamReader = new StreamReader(MemoryStream);
                return StreamReader.ReadToEnd();
            }
        }

        public static T DeserializeJSON<T>(string Json)
        {
            var Instance = typeof(T);

            using (MemoryStream MemoryStream = new MemoryStream(Encoding.Unicode.GetBytes(Json)))
            {
                DataContractJsonSerializer Deserializer = new DataContractJsonSerializer(Instance);
                return (T)Deserializer.ReadObject(MemoryStream);
            }
        }
    }
}
